// Card.cpp: implementation of the CCard class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "View.h"
#include "dclib_wrap.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CDclibWrap::CDclibWrap()
{
	handle = 0;
}

CDclibWrap::~CDclibWrap()
{
}

int CDclibWrap::Init()
{
	return DC_Init(&handle);
}

int CDclibWrap::End()
{
	return DC_End(handle);
}

int CDclibWrap::SelectCard(int card_num)
{
	return DC_SelectCard(handle,card_num);
}


int CDclibWrap::GetMaxCards()
{
	return DC_GetMaxCards(handle);
}

int CDclibWrap::GetCurCard()
{
	return DC_GetCurCard(handle);
}

int CDclibWrap::GetVersion(DWORD *DllVer,DWORD *DrvVer,DWORD *ChipVer)
{
	return DC_GetVersion(handle,DllVer,DrvVer,ChipVer);
}

int CDclibWrap::GetMaxChannels()
{
	return DC_GetMaxChannels(handle);
}

int CDclibWrap::WriteReg(DWORD offset,DWORD data)
{
	return DC_WriteReg(handle,offset,data);
}

int CDclibWrap::ReadReg(DWORD offset,DWORD *data)
{
	return DC_ReadReg(handle,offset,data);
}

int CDclibWrap::GenIoIrqSet(DWORD ipen, DWORD inen)
{
	return DC_GenIoIrqSet(handle,ipen,inen);
}

int CDclibWrap::GenIoRead(DWORD *data)
{
	return DC_GenIoRead(handle,data);
}

int CDclibWrap::GenIoReadOvl(DWORD *data,DWORD *status)
{
	return DC_GenIoReadOvl(handle,data,status);
}

int CDclibWrap::GenIoCancelReadOvl()
{
	return DC_GenIoCancelReadOvl(handle);
}

int CDclibWrap::GenIoWrite(DWORD data)
{
	return DC_GenIoWrite(handle,data);
}


int CDclibWrap::GpioReadIn(int card_num,DWORD *data)
{
	return DC_GpioReadIn(handle,data);
}

int CDclibWrap::GpioWriteOut(int card_num,DWORD data)
{
	return DC_GpioWriteOut(handle,data);
}

int CDclibWrap::GpioWriteOE(DWORD data)
{
	return DC_GpioWriteOE(handle,data);
}

int CDclibWrap::Open(int channel,int Height,int Width,int Frames,int BitsPerClk)
{
	return DC_Open(handle,channel,Height,Width,Frames,BitsPerClk);
}

int CDclibWrap::Close(int channel)
{
	return DC_Close(handle,channel);
}


int CDclibWrap::Start(int channel)
{
	return DC_Start(handle,channel);
}

int CDclibWrap::Stop(int channel)
{
	return DC_Stop(handle,channel);
}



int CDclibWrap::GetFrame(int channel, int no_blocked,BYTE **buf,WORD *length)
{
	return DC_GetFrame(handle,channel,no_blocked,buf,length);
}

int CDclibWrap::CancelGetFrame(int channel)
{
	return DC_CancelGetFrame(handle,channel);
}


int CDclibWrap::SetCameraCableMode(int channel,int mode)
{
	return DC_SetCameraCableMode(handle,channel,mode);
}


int CDclibWrap::SetCapInfo(int channel,int HBP, int VBP, int ClkEdgeHigh, int HSyncEdgeHigh, int VSyncEdgeHigh, int LineArea, int Input10Bits)
{
	return DC_SetCapInfo(handle,channel,HBP, VBP, ClkEdgeHigh, HSyncEdgeHigh, VSyncEdgeHigh, LineArea, Input10Bits);
}

int CDclibWrap::SetFilter(int channel,DWORD mode,DWORD fsHz,DWORD cutoffHz,int offset,float q)
{
	return DC_SetFilter(handle,channel,mode,fsHz,cutoffHz,offset,q);
}

int CDclibWrap::SetExposure(int channel,int enable,int ActiveHigh,int width)
{
	return DC_SetExposure(handle,channel,enable,ActiveHigh,width);
}

int CDclibWrap::SetLookupTable(int channel,int index, WORD value)
{
	return DC_SetLookupTable(handle,channel,index,value);
}

// encoder 
int CDclibWrap::SetEncCounter(int channel,DWORD val)
{
	return DC_SetEncCounter(handle,channel,val);
}

int CDclibWrap::GetEncCounter(int channel,DWORD *val)
{
	return DC_GetEncCounter(handle,channel,val);
}

int CDclibWrap::SetTrgH(int channel,int CountSrc,int CntSrcInvert,int TrgSrc,int TrgSrcInvert,int OutInvert,WORD Width,WORD Numbers)
{
	return DC_SetTrgH(handle,channel,CountSrc,CntSrcInvert,TrgSrc,TrgSrcInvert,OutInvert,Width,Numbers);
}

int CDclibWrap::SetTrgV(int channel,int CountSrc,int CntSrcInvert,int TrgSrc,int TrgSrcInvert,int OutInvert,WORD Width,WORD Numbers)
{
	return DC_SetTrgV(handle,channel,CountSrc,CntSrcInvert,TrgSrc,TrgSrcInvert,OutInvert,Width,Numbers);
}


int CDclibWrap::SetSyncOut(int channel,int Source,int Invert,int OE)
{
	return DC_SetSyncOut(handle,channel,Source,Invert,OE);
}

int CDclibWrap::SyncOutToggle(int channel,WORD width)
{
	return DC_SyncOutToggle(handle,channel,width);
}

// PLL control functions
int CDclibWrap::SetClkOutFreq(int clk_o_number,int ref_number)
{
	return DC_SetClkOutFreq(handle,clk_o_number,ref_number);
}

// I2C control functions
void CDclibWrap::I2cInit(int channel,int DelayCnt)
{
	DC_I2cInit(handle,channel,DelayCnt);
}

void CDclibWrap::I2cRst(int channel)
{
	DC_I2cRst(handle,channel);
}

void CDclibWrap::I2cWrite(int channel,BYTE data)
{
	DC_I2cWrite(handle,channel,data);
}

int CDclibWrap::I2cRead(int channel)
{
	return DC_I2cRead(handle,channel);
}

void CDclibWrap::I2cStart(int channel)
{
	DC_I2cStart(handle,channel);
}

void CDclibWrap::I2cStop(int channel)
{
	DC_I2cStop(handle,channel);
}

// EEPROM program
int CDclibWrap::Prog(void *report, char *filename)
{
	return DC_Prog(handle,report,filename);
}

