//
// ViewView.cpp : implementation of the CViewView class
//
//
#include <mmsystem.h>
#include "stdafx.h"

#include "dclibdef.h"
#include "View.h"
#include "ViewDoc.h"
#include "ViewView.h"
#include "imglib.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// capture size

#define WIDTH	1392
#define HEIGHT	1040

#define FRAMES	32	

// display window
#define DWIDTH	800
#define DHEIGHT	600

///////////////////////////////////////////////////////////////

BYTE image[DWIDTH*DHEIGHT*3];
BOOL bFlagDisplay = FALSE;

///////////////////////////////////////////////////////////////////
CRect rectImage(5, 5, DWIDTH+5, DHEIGHT+40);
///////////////////////////////////////////////////////////////////

UINT ThreadFunc(LPVOID lpData){
	CViewView *pView = (CViewView *)lpData;
	return pView->Capture(0);
}


UINT ThreadFunc1(LPVOID lpData){

	CViewView *pView = (CViewView *)lpData;
	return pView->Capture(1);
}


/////////////////////////////////////////////////////////////////////////////
// CViewView

IMPLEMENT_DYNCREATE(CViewView, CFormView)

BEGIN_MESSAGE_MAP(CViewView, CFormView)
	//{{AFX_MSG_MAP(CViewView)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_START_VIEW, OnButtonStartView)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewView construction/destruction

CViewView::CViewView()
	: CFormView(CViewView::IDD)
{
	//{{AFX_DATA_INIT(CViewView)
	m_Freq = 20;
	//}}AFX_DATA_INIT
	// TODO: add construction code here

	m_Over[0] = 0;
	m_Over[1] = 0;

	m_Cap = new CDclibWrap();

	if (!m_Cap->Init()) {;
		DWORD DllVer,DrvVer,ChipVer;

		m_Cap->GetVersion(&DllVer,&DrvVer,&ChipVer);
		char buf[256];
		sprintf(buf,"Check Version!!, DllVer = %4x, DrvVer=%4x,ChipVer=%4x",DllVer,DrvVer,ChipVer);
		//if (DllVer<0x300 || DrvVer<0x300 || ChipVer<0x300) {
		//	AfxMessageBox(buf);
		//}
		AfxMessageBox(buf);

		b_BoardInstalled = m_Cap->GetMaxCards();
		m_Cap->SelectCard(0);	// first card
		m_Cap->SetCameraCableMode(0,0);	
		m_Cap->SetClkOutFreq(10*m_Freq,400);
		m_Cap->SetTrgH(0,0,0,0,0,1,50,WIDTH+100);
	}
	else {
		b_BoardInstalled = 0;
	}
}

CViewView::~CViewView()
{
	if (b_BoardInstalled) {
		m_Cap->CancelGetFrame(0);
		m_Cap->Stop(0);
		m_Cap->End();
		delete m_Cap;
	}
	bFlagDisplay = FALSE;
}


void CViewView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewView)
	DDX_Control(pDX, IDC_EDIT_OVER1, m_edOver1);
	DDX_Control(pDX, IDC_EDIT_OVER0, m_edOver0);
	DDX_Control(pDX, IDC_EDIT_DIFF, m_Diff);
	DDX_Control(pDX, IDC_EDIT_RATE2, m_Rate2);
	DDX_Control(pDX, IDC_EDIT_RATE1, m_Rate1);
	DDX_Control(pDX, IDC_COMBO_DISPMODE, m_DispMode);
	DDX_Control(pDX, IDC_BUTTON_START_VIEW, m_btnStartStop);
	DDX_Text(pDX, IDC_EDIT_FREQ, m_Freq);
	DDV_MinMaxUInt(pDX, m_Freq, 10, 65);
	//}}AFX_DATA_MAP
}

BOOL CViewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CFormView::PreCreateWindow(cs);
}

void CViewView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	m_DispMode.AddString("DISP_CH0");
	m_DispMode.AddString("DISP_CH1");
	m_DispMode.SetCurSel(0);

	m_Rate1.ReplaceSel("0");
	m_Rate2.ReplaceSel("0");

	m_edOver0.ReplaceSel("0");
	m_edOver1.ReplaceSel("0");

}

/////////////////////////////////////////////////////////////////////////////
// CViewView diagnostics

#ifdef _DEBUG
void CViewView::AssertValid() const
{
	CFormView::AssertValid();
}

void CViewView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CViewDoc* CViewView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CViewDoc)));
	return (CViewDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CViewView message handlers

void CViewView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	BITMAPINFOHEADER m_bmiHdr;
	BITMAPFILEHEADER m_bmfHdr;

	MakeBMPHeader(&m_bmiHdr, &m_bmfHdr, DWIDTH, DHEIGHT);
	SetDIBitsToDevice(dc.m_hDC, 5, 30,	m_bmiHdr.biWidth, m_bmiHdr.biHeight,
						0, 0, 0, (WORD)m_bmiHdr.biHeight, image,
						(LPBITMAPINFO)&m_bmiHdr, BI_RGB);
}



void CViewView::OnButtonStartView() 
{
	// TODO: Add your control notification handler code here
	if (b_BoardInstalled) {
		if ( bFlagDisplay == FALSE ) {
			bFlagDisplay = TRUE;

			m_Frames[0] = 0;
			m_Frames[1] = 0;
			m_Over[0]=0;
			m_Over[1]=0;
			UpdateRate();

			UpdateData(TRUE);
			m_Cap->SetClkOutFreq(5*m_Freq,200);

			AfxBeginThread(ThreadFunc, (LPVOID)this, THREAD_PRIORITY_NORMAL);
			AfxBeginThread(ThreadFunc1, (LPVOID)this, THREAD_PRIORITY_NORMAL);

			m_btnStartStop.SetWindowText("StopDisplay");
		}
		else {
			bFlagDisplay = FALSE;
			m_Cap->CancelGetFrame(0);
			m_Cap->CancelGetFrame(1);
			m_btnStartStop.SetWindowText("StartDisplay");
		}
	}
}


void CViewView::OnDestroy() 
{
	CFormView::OnDestroy();
	// TODO: Add your message handler code here
}

void CViewView::UpdateRate()
{
	char buf[30];
	sprintf(buf,"%d",m_Frames[0]);
	m_Rate1.SetWindowText(buf);

	sprintf(buf,"%d",m_Frames[1]);
	m_Rate2.SetWindowText(buf);

	sprintf(buf,"%d",m_Frames[0]-m_Frames[1]);
	m_Diff.SetWindowText(buf);

	sprintf(buf,"%d",m_Over[0]);
	m_edOver0.SetWindowText(buf);

	sprintf(buf,"%d",m_Over[1]);
	m_edOver1.SetWindowText(buf);
}



UINT CViewView::Capture(int ch)
{
	BYTE *buf;

	m_Cap->Open(ch,
				HEIGHT,
				WIDTH,
				FRAMES,	// frame numbers
				8		// mono mode, BitsPerClk
				);		
				
	m_Cap->SetCapInfo(	ch,
				0,	// HBP
				0,	// VBP
				1,	// ClkEdgeHigh
				1,	// HSyncEdgeHigh
				0,	// VSyncEdgeHigh
				0,	// LineArea
				1	// Input10Bits
				);

	m_Cap->SetTrgH(ch,1,0,0,0,1,50,WIDTH+200);
	m_Cap->SetTrgV(ch,4,1,0,0,1,10,HEIGHT+20);

	m_Cap->Start(ch);

	WORD length;
	int ret;

	do {
		ret = m_Cap->GetFrame(ch,0,&buf,&length);

		if (m_DispMode.GetCurSel()==ch) {
			if (length)  {
				RAWtoBMPImage((BYTE *)buf, image,DWIDTH, DHEIGHT);
				InvalidateRect(&rectImage, FALSE);
			}
		}
		if (length>0) {
			if (ret==DC_ERR_FRAME_OVER_RUN) {
				m_Over[ch]++;
			}
			m_Frames[ch]++;
			UpdateRate();
		}
	}

	while(bFlagDisplay == TRUE);
	m_Cap->Stop(ch);
	m_Cap->Close(ch);
	return 0;
}
