// Card.h: interface for the CCard class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIGITALCAPTURELIB_H__C045D535_742A_48B2_9895_0855108AB82F__INCLUDED_)
#define AFX_DIGITALCAPTURELIB_H__C045D535_742A_48B2_9895_0855108AB82F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "dclibdef.h"

class CDclibWrap
{

public:

	CDclibWrap();
	virtual ~CDclibWrap();

	int handle;

	int Init();
	int End();

	int GetMaxCards();
	int SelectCard(int card_num);
	int GetCurCard();

	int GetMaxChannels();

	int GetVersion(DWORD *DllVer,DWORD *DrvVer,DWORD *ChipVer);

	int WriteReg(DWORD offset,DWORD data);
	int ReadReg(DWORD offset,DWORD *data);

	int GenIoIrqSet(DWORD ipen, DWORD inen);
	int GenIoRead(DWORD *data);
	int GenIoReadOvl(DWORD *data,DWORD *status);
	int GenIoCancelReadOvl();
	int GenIoWrite(DWORD data);

	int GpioReadIn(int card_num,DWORD *data);
	int GpioWriteOut(int card_num,DWORD data);
	int GpioWriteOE(DWORD data);

	int Open(int channel,int Height,int Width,int Frames,int BitsPerClk);
	int Close(int channel);

	int Start(int channel);
	int Stop(int channel);

	int GetFrame(int channel, int no_blocked,BYTE **buf,WORD *length);
	int CancelGetFrame(int channel);

	int SetCameraCableMode(int channel,int mode);
	int SetCapInfo(int channel,int HBP, int VBP, int ClkEdgeHigh, int HSyncHigh, int VSyncHigh, int LineArea, int Input10Bits);
	int SetFilter(int channel,DWORD mode,DWORD fsHz,DWORD cutoffHz,int offset,float q);
	int SetExposure(int channel,int enable,int high_active,int width);
	int SetLookupTable(int channel,int index, WORD value);

	// encoder 
	int SetEncCounter(int channel,DWORD val);
	int GetEncCounter(int channel,DWORD *val);

	int SetTrgH(int channel,int CountSrc,int CntSrcInvert,int TrgSrc,int TrgSrcInvert,int OutInvert,WORD Width,WORD Numbers);
	int SetTrgV(int channel,int CountSrc,int CntSrcInvert,int TrgSrc,int TrgSrcInvert,int OutInvert,WORD Width,WORD Numbers);
	int SetSyncOut(int channel,int Source,int Invert,int OE);
	int SyncOutToggle(int channel,WORD width);

	// PLL control functions
	int SetClkOutFreq(int clk_o_number,int ref_number);

	// I2C control functions
	void I2cInit(int channel,int DelayCnt);
	void I2cRst(int channel);
	void I2cWrite(int channel,BYTE data);
	int I2cRead(int channel);
	void I2cStart(int channel);
	void I2cStop(int channel);

	// EEPROM program
	int Prog(void *report, char *filename);
};

#endif // !defined(AFX_DIGITALCAPTURELIB_H__C045D535_742A_48B2_9895_0855108AB82F__INCLUDED_)
