//
// ViewView.cpp : implementation of the CViewView class
//
//
#include <mmsystem.h>
#include "stdafx.h"

#include "dclibdef.h"
#include "View.h"
#include "ViewDoc.h"
#include "chan.h"
#include "ViewView.h"
#include "imglib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CViewView

IMPLEMENT_DYNCREATE(CViewView, CFormView)

BEGIN_MESSAGE_MAP(CViewView, CFormView)
	//{{AFX_MSG_MAP(CViewView)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CAM_RST_CH1, OnButtonCamRstCh1)
	ON_BN_CLICKED(IDC_BUTTON_CAM_RST_CH2, OnButtonCamRstCh2)
	ON_BN_CLICKED(IDC_BUTTON_CH1_SAVE, OnButtonCh1Save)
	ON_BN_CLICKED(IDC_BUTTON_I2C1_READ, OnButtonI2c1Read)
	ON_BN_CLICKED(IDC_BUTTON_I2C1_WRITE, OnButtonI2c1Write)
	ON_BN_CLICKED(IDC_BUTTON_I2C2_READ, OnButtonI2c2Read)
	ON_BN_CLICKED(IDC_BUTTON_I2C2_WRITE, OnButtonI2c2Write)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_CH2, OnButtonSaveCh2)
	ON_BN_CLICKED(IDC_BUTTON_START_CH1, OnButtonStartCh1)
	ON_BN_CLICKED(IDC_BUTTON_START_CH2, OnButtonStartCh2)
	ON_CBN_SELCHANGE(IDC_COMBO_DISP_MODE, OnSelchangeComboDispMode)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_CLK_CHANGE, OnButtonClkChange)
	ON_CBN_SELCHANGE(IDC_COMBO_SELECT_BOARD, OnSelchangeComboSelectBoard)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewView construction/destruction

CViewView::CViewView()
	: CFormView(CViewView::IDD)
{
	//{{AFX_DATA_INIT(CViewView)
	m_edClkFreq = 54;
	m_edI2c1Addr = _T("0");
	m_edI2c1Data = _T("0");
	m_edI2c2Addr = _T("0");
	m_edI2c2Data = _T("0");
	//}}AFX_DATA_INIT
	// TODO: add construction code here

	m_Cap = new CDclibWrap();

	if (!m_Cap->Init()) {;
		m_bBoardInstalled = m_Cap->GetMaxCards();

		m_Cap->SelectCard(0);	// first card

		DWORD DllVer,DrvVer,ChipVer;

		m_Cap->GetVersion(&DllVer,&DrvVer,&ChipVer);
		char buf[256];
		sprintf(buf,"Check Version!!, DllVer = %4x, DrvVer=%4x,ChipVer=%4x",DllVer,DrvVer,ChipVer);
		if (DllVer<0x300 || DrvVer<0x300 || ChipVer<0x300) {
			AfxMessageBox(buf);
		}


		//
		// Clock output freq setting function
		// freq = 40Mhz * (clk_o_number/ref_number)
		//
		m_Cap->SetClkOutFreq(5*m_edClkFreq,200);	

		for (int i=0;i<2;i++) {
			m_Cap->SetCameraCableMode(i,1);	// I2C mode
			m_Cap->I2cInit(i,1);
			m_Chan[i] = new CChan(i,this,m_Cap);
			m_Chan[i]->CamReset();
		}
	}
	else {
		m_bBoardInstalled = 0;
	}

}

CViewView::~CViewView()
{
	if (m_bBoardInstalled) {
		for (int i=0;i<2;i++) {
			delete m_Chan[i];
		}
		m_Cap->End();
	}
}


void CViewView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewView)
	DDX_Control(pDX, IDC_EDIT_BOARD_NUMBERS, m_edBoardNumbers);
	DDX_Control(pDX, IDC_COMBO_SELECT_BOARD, m_cbSelectBoard);
	DDX_Control(pDX, IDC_EDIT_RATE_CH1, m_edCh1Rate);
	DDX_Control(pDX, IDC_EDIT_RATE_CH2, m_edCh2Rate);
	DDX_Control(pDX, IDC_BUTTON_START_CH2, m_btnCaptureStart2);
	DDX_Control(pDX, IDC_BUTTON_START_CH1, m_btnCaptureStart1);
	DDX_Control(pDX, IDC_COMBO_DISP_MODE, m_cbDispMode);
	DDX_Control(pDX, IDC_COMBO_CH2_MODE, m_cbCh2Mode);
	DDX_Control(pDX, IDC_COMBO_CH1_MODE, m_cbCh1Mode);
	DDX_Text(pDX, IDC_EDIT_CLK_FREQ, m_edClkFreq);
	DDV_MinMaxUInt(pDX, m_edClkFreq, 2, 80);
	DDX_Text(pDX, IDC_EDIT_I2C1_ADDR, m_edI2c1Addr);
	DDX_Text(pDX, IDC_EDIT_I2C1_DATA, m_edI2c1Data);
	DDX_Text(pDX, IDC_EDIT_I2C2_ADDR, m_edI2c2Addr);
	DDX_Text(pDX, IDC_EDIT_I2C2_DATA, m_edI2c2Data);
	//}}AFX_DATA_MAP
}

BOOL CViewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CFormView::PreCreateWindow(cs);
}

void CViewView::OnInitialUpdate()
{

	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	m_cbDispMode.AddString("FULL_CH0");
	m_cbDispMode.AddString("FULL_CH1");
	m_cbDispMode.AddString("SPLIT_H");
	m_cbDispMode.AddString("SPLIT_V");
	m_cbDispMode.SetCurSel(0);

	m_cbCh1Mode.AddString(" 640x512");
	m_cbCh1Mode.AddString("1280x1024");
	m_cbCh1Mode.SetCurSel(0);

	m_cbCh2Mode.AddString(" 640x512");
	m_cbCh2Mode.AddString("1280x1024");
	m_cbCh2Mode.SetCurSel(0);

	m_Chan[0]->SetCapMode(0);
	m_Chan[1]->SetCapMode(0);

	m_Chan[0]->SetDispMode(1);
	m_Chan[1]->SetDispMode(0);
	m_edCh1Rate.ReplaceSel("0");
	m_edCh2Rate.ReplaceSel("0");

	{
		char buf[30];
		int i;

		for (i=0;i<m_bBoardInstalled;i++) {
			sprintf(buf,"Board = %d",i);
			m_cbSelectBoard.AddString(buf);
		}
		m_cbSelectBoard.SetCurSel(0);

		sprintf(buf,"%d",m_bBoardInstalled);
		m_edBoardNumbers.SetWindowText(buf);
	}
	SetTimer(0, 1000, NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CViewView diagnostics

#ifdef _DEBUG
void CViewView::AssertValid() const
{
	CFormView::AssertValid();
}

void CViewView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CViewDoc* CViewView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CViewDoc)));
	return (CViewDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CViewView message handlers

void CViewView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	for (int i=0;i<2;i++) {
		m_Chan[i]->Draw(&dc);
	}
}



void CViewView::OnDestroy() 
{
	CFormView::OnDestroy();
	// TODO: Add your message handler code here
	KillTimer(0);
}


void CViewView::I2cWrite(int ch, int addr,UINT data)
{
	m_Chan[ch]->I2cWrite(addr,data);
}


UINT CViewView::I2cRead(int ch, int addr)
{
	return m_Chan[ch]->I2cRead(addr);
}

void CViewView::OnButtonCamRstCh1() 
{
	// TODO: Add your control notification handler code here
	m_Chan[0]->CamReset();

	
}

void CViewView::OnButtonCamRstCh2() 
{
	// TODO: Add your control notification handler code here
	m_Chan[1]->CamReset();
	
}

void CViewView::OnButtonCh1Save() 
{
	// TODO: Add your control notification handler code here

	m_Chan[0]->SaveImage();
	
}

void CViewView::OnButtonI2c1Read() 
{
	UINT chan,addr,data;

	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	chan = 0;
	sscanf(m_edI2c1Addr,"%2x",&addr);
	data = m_Chan[chan]->I2cRead(addr);
	m_edI2c1Data.Format("%4x",data);
	UpdateData(FALSE);
	
}

void CViewView::OnButtonI2c1Write() 
{
	UINT chan,addr,data;
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);
	chan = 0;
	sscanf(m_edI2c1Addr,"%2x",&addr);
	sscanf(m_edI2c1Data,"%4x",&data);
	m_Chan[chan]->I2cWrite(addr,data);
	
}

void CViewView::OnButtonI2c2Read() 
{
	UINT chan,addr,data;

	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	chan = 1;
	sscanf(m_edI2c2Addr,"%2x",&addr);
	data = m_Chan[chan]->I2cRead(addr);
	m_edI2c2Data.Format("%4x",data);
	UpdateData(FALSE);
}

void CViewView::OnButtonI2c2Write() 
{
	UINT chan,addr,data;
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);
	chan = 1;
	sscanf(m_edI2c2Addr,"%2x",&addr);
	sscanf(m_edI2c2Data,"%4x",&data);
	m_Chan[chan]->I2cWrite(addr,data);
}

void CViewView::OnButtonSaveCh2() 
{
	m_Chan[1]->SaveImage();

}


void CViewView::OnButtonStartCh1() 
{
	int ch = 0;

	// TODO: Add your control notification handler code here
	if (m_bBoardInstalled) {
		if (!m_Chan[ch]->IsRunning()) {
			UpdateData(TRUE);
			m_Chan[ch]->SetCapMode(m_cbCh1Mode.GetCurSel());

			m_Chan[ch]->Start();
			m_btnCaptureStart1.SetWindowText("Capture Stop");
		}
		else {
			m_Chan[ch]->Stop();
			m_btnCaptureStart1.SetWindowText("Capture Start");
		}
	}

}


void CViewView::OnButtonStartCh2() 
{
	int ch = 1;

	// TODO: Add your control notification handler code here
	if (m_bBoardInstalled) {
		if (!m_Chan[ch]->IsRunning()) {
			UpdateData(TRUE);
			m_Chan[ch]->SetCapMode(m_cbCh2Mode.GetCurSel());
			m_Chan[ch]->Start();
			m_btnCaptureStart2.SetWindowText("Capture Stop");
		}
		else {
			m_Chan[ch]->Stop();
			m_btnCaptureStart2.SetWindowText("Capture Start");
		}
	}

}

void CViewView::OnSelchangeComboDispMode() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	if (m_cbDispMode.GetCurSel()==0) {
		m_Chan[0]->SetDispMode(1);
		m_Chan[1]->SetDispMode(0);
	}
	if (m_cbDispMode.GetCurSel()==1) {
		m_Chan[0]->SetDispMode(0);
		m_Chan[1]->SetDispMode(1);
	}
}

void CViewView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	if (nIDEvent==0) {

		char buf[30];
		sprintf(buf,"%d",m_Chan[0]->GetFPS());
		m_edCh1Rate.SetWindowText(buf);

		sprintf(buf,"%d",m_Chan[1]->GetFPS());
		m_edCh2Rate.SetWindowText(buf);
	}
	CFormView::OnTimer(nIDEvent);
}

void CViewView::OnButtonClkChange() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_Cap->SetClkOutFreq(5*m_edClkFreq,200);	
}

void CViewView::OnSelchangeComboSelectBoard() 
{
	// TODO: Add your control notification handler code here
	int i;
	for (i=0;i<2;i++) {
		if (m_Chan[i]->IsRunning()) {
			m_Chan[i]->Stop();
			m_btnCaptureStart2.SetWindowText("Capture Start");
		}
	}

	m_Cap->SelectCard(m_cbSelectBoard.GetCurSel());

	m_Cap->SetClkOutFreq(5*m_edClkFreq,200);	

	for (i=0;i<2;i++) {
		m_Cap->SetCameraCableMode(i,1);	// I2C mode
		m_Cap->I2cInit(i,1);
		m_Chan[i]->CamReset();
	}
}
