// ViewView.h : interface of the CViewView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_VIEWVIEW_H__BC8E86CC_787D_11D5_AF58_00A024CDB4CE__INCLUDED_)
#define AFX_VIEWVIEW_H__BC8E86CC_787D_11D5_AF58_00A024CDB4CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "dclib_wrap.h"
#include "chan.h"

class CViewView : public CFormView
{
protected: // create from serialization only
	CViewView();
	DECLARE_DYNCREATE(CViewView)

public:
	//{{AFX_DATA(CViewView)
	enum { IDD = IDD_VIEW_FORM };
	CEdit	m_edBoardNumbers;
	CComboBox	m_cbSelectBoard;
	CEdit	m_edCh1Rate;
	CEdit	m_edCh2Rate;
	CButton	m_btnCaptureStart2;
	CButton	m_btnCaptureStart1;
	CComboBox	m_cbDispMode;
	CComboBox	m_cbCh2Mode;
	CComboBox	m_cbCh1Mode;
	UINT	m_edClkFreq;
	CString	m_edI2c1Addr;
	CString	m_edI2c1Data;
	CString	m_edI2c2Addr;
	CString	m_edI2c2Data;
	//}}AFX_DATA

// Attributes
public:
	CViewDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CViewView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	int m_bBoardInstalled;

	CDclibWrap *m_Cap;

	CChan *m_Chan[2];

	virtual ~CViewView();

	void I2cWrite(int ch, int addr,UINT data);
	UINT I2cRead(int ch, int addr);
	UINT Capture(int ch);



#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif


protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CViewView)
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnButtonCamRstCh1();
	afx_msg void OnButtonCamRstCh2();
	afx_msg void OnButtonCh1Save();
	afx_msg void OnButtonI2c1Read();
	afx_msg void OnButtonI2c1Write();
	afx_msg void OnButtonI2c2Read();
	afx_msg void OnButtonI2c2Write();
	afx_msg void OnButtonSaveCh2();
	afx_msg void OnButtonStartCh1();
	afx_msg void OnButtonStartCh2();
	afx_msg void OnSelchangeComboDispMode();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButtonClkChange();
	afx_msg void OnSelchangeComboSelectBoard();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in ViewView.cpp
inline CViewDoc* CViewView::GetDocument()
   { return (CViewDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VIEWVIEW_H__BC8E86CC_787D_11D5_AF58_00A024CDB4CE__INCLUDED_)
